﻿using Hidemaru;
using System;
using System.Windows;
using System.Windows.Media;

namespace TextInsert04
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {
        public string macrodir;     // 秀丸マクロディレクトリ

        public MainWindow()
        {
            InitializeComponent();
            // カーソル位置にテキストを挿入
            Hm.Edit.LineText = "開始";
            // マクロディレクトリを取得
            macrodir = (string)(dynamic)Hm.Macro.Var["macrodir"];
            // メッセージボックスで、マクロディレクトリの内容を確認する
            // MessageBox.Show(macrodir);
        }
        private void btn0_Click(object sender, RoutedEventArgs e)
        {
            // ボタンの色を変更する
            var bc = new BrushConverter();
            btn0.Background = (Brush)bc.ConvertFrom("#FFE21C1C");

            // 秀丸マクロを実行する
            Hm.Macro.Exec.File(macrodir + @"\TextInsert00.mac");
        }
    }

    public class HmEntry
    {
        public static Window WpfForm;

        public static IntPtr CreateForm()
        {
            // 秀丸マクロから呼び出されたときに実行されるメソッド
            if (WpfForm != null)
            {
                WpfForm.Close();
                WpfForm = null;
            }
            WpfForm = new MainWindow();
            WpfForm.Show();
            return (IntPtr)1;
        }

        public static IntPtr OnDetathMethod()
        {
            // 秀丸エディタが閉じられる前に実行されるコード
            // このWPFアプリケーションを終了します。
            if (WpfForm != null)
            {
                WpfForm.Close();
                WpfForm = null;
            }
            return (IntPtr)1;
        }
    }
}
